summaryrefslogtreecommitdiff
path: root/tests/touch/not-owner.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/touch/not-owner.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/touch/not-owner.sh')
-rwxr-xr-xtests/touch/not-owner.sh55
1 files changed, 55 insertions, 0 deletions
diff --git a/tests/touch/not-owner.sh b/tests/touch/not-owner.sh
new file mode 100755
index 000000000..63b8af249
--- /dev/null
+++ b/tests/touch/not-owner.sh
@@ -0,0 +1,55 @@
+#!/bin/sh
+# Make sure that touch gives reasonable diagnostics when applied
+# to an unwritable directory owned by some other user.
+
+# Copyright (C) 2003-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ touch
+
+if env -- test -w /; then
+ skip_ you have write access to /.
+fi
+
+if env -- test -O / || env -- test -G /; then
+ skip_ "you own /."
+fi
+
+skip_if_root_
+
+
+# Before fileutils-4.1, we'd get the following misleading
+# diagnostic instead of '...: Permission denied'.
+# touch: creating '/': Is a directory
+touch / > out 2>&1 && fail=1
+
+# On SunOS4, EPERM is 'Not owner'.
+# On some *BSD systems it's 'Operation not permitted'.
+# On a system where root file system is mounted read-only
+# it's 'Read-only file system'.
+for msg in 'Not owner' 'Operation not permitted' 'Permission denied' \
+ 'Read-only file system'; do
+ cat > exp <<EOF
+touch: setting times of '/': $msg
+EOF
+
+ cmp out exp > /dev/null 2>&1 && { match=1; break; }
+done
+test "$match" = 1 || fail=1
+
+test $fail = 1 && compare exp out
+
+Exit $fail